## ukui-panel 4.0.0.6

=== CMakeLists.txt ===
﻿cmake_minimum_required(VERSION 3.1.0 FATAL_ERROR)
project(ukui-panel)

option(WITH_SCREENSAVER_FALLBACK "Include support for converting the deprecated 'screensaver' plugin to 'quicklaunch'. This requires the ukui-leave (ukui-session) to be installed in runtime." OFF)

# additional cmake files
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake)

macro(setByDefault VAR_NAME VAR_VALUE)
  if(NOT DEFINED ${VAR_NAME})
    set (${VAR_NAME} ${VAR_VALUE})
  endif(NOT DEFINED ${VAR_NAME})
endmacro()

include(GNUInstallDirs)

setByDefault(CUSTOM_QT_5_6_VERSION Yes)
setByDefault(CUSTOM_QT_5_12_VERSION No)

set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_POSITION_INDEPENDENT_CODE ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTORCC ON)

set(KF5_MINIMUM_VERSION "5.18.0")
set(QT_MINIMUM_VERSION "5.6.1")

find_package(KF5WindowSystem ${KF5_MINIMUM_VERSION} REQUIRED)
find_package(Qt5 ${QT_MINIMUM_VERSION} CONFIG REQUIRED Widgets Core Quick QuickWidgets DBus X11Extras LinguistTools Xml)
find_package(X11 REQUIRED)

find_package(PkgConfig)
pkg_check_modules(Gsetting REQUIRED gsettings-qt)
include_directories(${Gsetting_INCLUDE_DIRS})
set(LIBRARIES
    ${Gsetting_LIBRARIES}
    -lukui-log4qt
)

# Patch Version
set(UKUI_VERSION 3.0)
set(UKUI_PANEL_PATCH_VERSION 0)
set(UKUI_MAJOR_VERSION 3)
set(UKUI_MINOR_VERSION 0)

#set(UKUI_TRANSLATIONS_DIR "${CMAKE_INSTALL_FULL_DATAROOTDIR}/ukui/translations/")
set(UKUI_PANEL_VERSION ${UKUI_MAJOR_VERSION}.${UKUI_MINOR_VERSION}.${UKUI_PANEL_PATCH_VERSION})
add_definitions("-DUKUI_PANEL_VERSION=\"${UKUI_PANEL_VERSION}\"")

include(./cmake/ukui-build-tools/modules/UKUiPreventInSourceBuilds.cmake)
#include(./cmake/ukui-build-tools/modules/UKUiTranslate.cmake)

# All UKUiCompilerSettings except CMAKE_MODULE_LINKER_FLAGS work just fine
# So we reset only these Flags after loading UKUiCompilerSettings
# ukui-build-tools:
#  set(CMAKE_MODULE_LINKER_FLAGS "-Wl,--no-undefined ${SYMBOLIC_FLAGS} ${CMAKE_MODULE_LINKER_FLAGS}")
message(STATUS "==OLD== CMAKE_MODULE_LINKER_FLAGS: ${CMAKE_MODULE_LINKER_FLAGS}")
set( OLD_CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS}")
set(CMAKE_MODULE_LINKER_FLAGS "${OLD_CMAKE_MODULE_LINKER_FLAGS} ${SYMBOLIC_FLAGS}")

# Warning: This must be before add_subdirectory(panel). Move with caution.
set(PLUGIN_DIR "${CMAKE_INSTALL_FULL_LIBDIR}/ukui-panel")
add_definitions(
    -DPLUGIN_DIR=\"${PLUGIN_DIR}\"
)
#Add PACKAGE_DATA_DIR
set(PACKAGE_DATA_DIR "/usr/share/ukui-panel")
add_definitions(
    -DPACKAGE_DATA_DIR=\"${PACKAGE_DATA_DIR}\"
    -DQT_MESSAGELOGCONTEXT
)

message(STATUS "CMAKE Module linker flags: ${CMAKE_MODULE_LINKER_FLAGS}")
message(STATUS "Panel plugins location: ${PLUGIN_DIR}")

#########################################################################
# Plugin system
# You can enable/disable building of the plugin using cmake options.
#    cmake -DWORLDCLOCK_PLUGIN=Yes .. # Enable worldclock plugin
#    cmake -DWORLDCLOCK_PLUGIN=No ..  # Disable worldclock plugin

include("cmake/BuildPlugin.cmake")
include(./cmake/ukui-build-tools/modules/UKUiTranslateDesktop.cmake)
include(./cmake/ukui-build-tools/modules/UKUiTranslationLoader.cmake)
set(ENABLED_PLUGINS) # list of enabled plugins
set(STATIC_PLUGINS) # list of statically linked plugins

setByDefault(QUICKLAUNCH_PLUGIN No)
if(QUICKLAUNCH_PLUGIN)
    list(APPEND STATIC_PLUGINS "quicklaunch")
    add_definitions(-DWITH_QUICKLAUNCH_PLUGIN)
    list(APPEND ENABLED_PLUGINS "Quicklaunch")
    add_subdirectory(plugin-quicklaunch)
endif()


setByDefault(SHOWDESKTOP_PLUGIN Yes)
if(SHOWDESKTOP_PLUGIN)
    list(APPEND ENABLED_PLUGINS "Show Desktop")
    add_subdirectory(plugin-showdesktop)
endif()


setByDefault(TASKBAR_PLUGIN Yes)
if(TASKBAR_PLUGIN)
    list(APPEND ENABLED_PLUGINS "taskbar")
    add_subdirectory(plugin-taskbar)
endif()

add_subdirectory(panel-daemon)
add_subdirectory(sni-daemon)
add_subdirectory(sni-xembed-proxy)
add_subdirectory(plugin-ukcc)

setByDefault(STATUSNOTIFIER_PLUGIN Yes)
if(STATUSNOTIFIER_PLUGIN)
    list(APPEND ENABLED_PLUGINS "statusnotifier")
    add_subdirectory(plugin-statusnotifier)
endif()

setByDefault(SPACER_PLUGIN Yes)
if(SPACER_PLUGIN)
    list(APPEND STATIC_PLUGINS "spacer")
    add_definitions(-DWITH_SPACER_PLUGIN)
    list(APPEND ENABLED_PLUGINS "Spacer")
    add_subdirectory(plugin-spacer)
endif()

setByDefault(CALENDAR_PLUGIN Yes)
if(CALENDAR_PLUGIN)
    list(APPEND ENABLED_PLUGINS "calendar")
    add_subdirectory(plugin-calendar)
endif(CALENDAR_PLUGIN)

setByDefault(STARTBAR_PLUGIN Yes)
if(STARTBAR_PLUGIN)
    list(APPEND ENABLED_PLUGINS "startbar")
    add_subdirectory(plugin-startbar)
endif(STARTBAR_PLUGIN)

#########################################################################

message(STATUS  "**************** The following plugins will be built ****************")
foreach (PLUGIN_STR ${ENABLED_PLUGINS})
    message(STATUS "  ${PLUGIN_STR}")
endforeach()
message(STATUS "*********************************************************************")

add_subdirectory(panel)

file(GLOB_RECURSE QRC_SOURCE_FILES ${CMAKE_CURRENT_SOURCE_DIR}/*.qrc)

## translation
#set(UKUI_TRANSLATIONS_DIR ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_DATAROOTDIR}/ukui/)
#add_definitions(
#    -DUKUI_TRANSLATIONS_DIR="${UKUI_TRANSLATIONS_DIR}"
#)
#if (NOT DEFINED UPDATE_TRANSLATIONS)
#    set(UPDATE_TRANSLATIONS "No")
#endif()

## To create a new ts file: lupdate -recursive . -target-language zh_CN -ts panel/resources/ukui-panel_zh_CN.ts
#file(GLOB TS_FILES "${CMAKE_CURRENT_SOURCE_DIR}/panel/resources/*.ts")

## cmake -DUPDATE_TRANSLATIONS=yes
#if (UPDATE_TRANSLATIONS)
#    qt5_create_translation(QM_FILES ${CMAKE_SOURCE_DIR} ${TS_FILES})
#else()
#    qt5_add_translation(QM_FILES ${TS_FILES})
#endif()
#add_custom_target(translations ALL DEPENDS ${QM_FILES})
#install(FILES ${QM_FILES} DESTINATION ${UKUI_TRANSLATIONS_DIR})

=== panel/CMakeLists.txt ===
project(ukui-panel LANGUAGES C CXX)

set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)

add_subdirectory(common)

set(PRIV_HEADERS
    panelpluginsmodel.h
    ukuipanel.h
    ukuipanelapplication.h
    ukuipanelapplication_p.h
    ukuipanellayout.h
    plugin.h
    pluginsettings_p.h
    contextmenu.h
)

# using UKUi namespace in the public headers.
set(PUB_HEADERS
    ukuipanelglobals.h
    pluginsettings.h
    iukuipanelplugin.h
    iukuipanel.h
    common/ukuisettings.h
    common/ukuiplugininfo.h
    common/common.h
    common/ukuigridlayout.h
    common/ukuiglobals.h
    common_fun/listengsettings.h
    common_fun/ukuipanel_infomation.h
    common_fun/dbus-adaptor.h
    common_fun/panel_commission.h
    customstyle.h
    xdg-desktop-file/xdgdesktopfile_p.h
    xdg-desktop-file/xdgdesktopfile.h
    xdg-desktop-file/xdgdirs.h
    xdg-desktop-file/xdgmacros.h
)

set(SOURCES
    main.cpp
    panelpluginsmodel.cpp
    windownotifier.cpp
    ukuipanel.cpp
    ukuipanelapplication.cpp
    ukuipanellayout.cpp
    plugin.cpp
    pluginsettings.cpp
    contextmenu.cpp
    common/ukuiplugininfo.cpp
    common/ukuisettings.cpp
    common/ukuigridlayout.cpp
    common_fun/listengsettings.cpp
    common_fun/ukuipanel_infomation.cpp
    common_fun/dbus-adaptor.cpp
    common_fun/panel_commission.cpp
    customstyle.cpp
    xdg-desktop-file/desktopenvironment_p.cpp
    xdg-desktop-file/xdgdesktopfile.cpp
    xdg-desktop-file/xdgdirs.cpp
)

set(PLUGIN_DESKTOPS_DIR "${CMAKE_INSTALL_FULL_DATAROOTDIR}/ukui/${PROJECT_NAME}")
set(QTX_LIBRARIES Qt5::Widgets Qt5::Xml Qt5::DBus)
set(UKUI_PANEL_MAN ../man/ukui-panel.1)
set(DESKTOP_FILE resources/ukui-panel.desktop)
set(IMAGE_DIR ./img/)
set(GSETTINGS_FILE resources/org.ukui.panel.settings.gschema.xml)
set(PANEL_GLOBAL_CONFIG_FILES resources/panel-commission.ini)
set(PANEL_GLOBAL_CONFIG_EXEC_FILES resources/panel-commission.sh
                            resources/ukui-panel-reset.sh resources/ukui-panel-config.sh)
file(GLOB UKUI_PANEL_CONFIG_FILES resources/*.conf)

add_definitions(-DCOMPILE_UKUI_PANEL)
add_definitions(-DPLUGIN_DESKTOPS_DIR=\"${PLUGIN_DESKTOPS_DIR}\")

if (WITH_SCREENSAVER_FALLBACK)
    message(STATUS "Building with conversion of deprecated 'screensaver' plugin")
    add_definitions(-DWITH_SCREENSAVER_FALLBACK "-DUKUI_LOCK_DESKTOP=\"${CMAKE_INSTALL_FULL_DATAROOTDIR}/applications/ukui-lockscreen.desktop\"")
endif ()


set_property(SOURCE ${DBUS_INTERFACE_SRCS} ${DBUS_ADAPTOR_SRCS} PROPERTY SKIP_AUTOGEN ON)
list(APPEND SOURCES "${DBUS_INTERFACE_SRCS}" "${DBUS_ADAPTOR_SRCS}")

QT5_ADD_DBUS_INTERFACE(libqtxdg_DBUS_INTERFACE_SRCS
    xdg-desktop-file/dbus/org.freedesktop.Application.xml
    application_interface
)

# 翻译文件
file(GLOB TS_FILES "translation/*.ts")
# 更新翻译并创建.qm文件
qt5_create_translation(QM_FILES ${PROJECT_SOURCE_DIR} ${TS_FILES})
add_executable(${PROJECT_NAME}
    ${PUB_HEADERS}
    ${PRIV_HEADERS}
    ${QM_FILES}
    ${SOURCES}
    ${libqtxdg_DBUS_INTERFACE_SRCS}
)

find_package(PkgConfig)
pkg_check_modules(GLIB2 REQUIRED glib-2.0)
pkg_check_modules(GIO2 REQUIRED gio-2.0)
pkg_check_modules(Gsetting REQUIRED gsettings-qt)
include_directories(${GLIB2_INCLUDE_DIRS})
include_directories(${GIO2_INCLUDE_DIRS})
include_directories(${Gsetting_INCLUDE_DIRS})

find_package(PkgConfig REQUIRED)
find_package(KF5WindowSystem)
pkg_check_modules(KYSDKWAYLANDHELPER_PKG kysdk-waylandhelper)

#ADD_DEFINITIONS(-DQT_NO_KEYWORDS)
target_link_libraries(${PROJECT_NAME}
    ${LIBRARIES}
    ${QTX_LIBRARIES}
    KF5::WindowSystem
    ${STATIC_PLUGINS}
    ${GLIB2_LIBRARIES}
    ${GIO2_LIBRARIES}
    ${Gsetting_LIBRARIES}
    Qt${QT_VERSION_MAJOR}::Quick
)

target_include_directories(${PROJECT_NAME} PRIVATE ${KYSDKWAYLANDHELPER_PKG_INCLUDE_DIRS})
target_link_directories(${PROJECT_NAME} PRIVATE ${KYSDKWAYLANDHELPER_PKG_LIBRARY_DIRS} KF5::WindowSystem)
target_link_libraries(${PROJECT_NAME} ${KYSDKWAYLANDHELPER_PKG_LIBRARIES})

target_compile_definitions(${PROJECT_NAME}
    PRIVATE
        "UKUI_RELATIVE_SHARE_DIR=\"${UKUI_RELATIVE_SHARE_DIR}\""
        "UKUI_RELATIVE_SHARE_TRANSLATIONS_DIR=\"${UKUI_RELATIVE_TRANSLATIONS_DIR}\""
        "UKUI_SHARE_TRANSLATIONS_DIR=\"${UKUI_TRANSLATIONS_DIR}\""
        "UKUI_GRAPHICS_DIR=\"${UKUI_GRAPHICS_DIR}\""
        "UKUI_DATA_DIR=\"${UKUI_DATA_DIR}\""   
        "UKUI_INSTALL_PREFIX=\"${CMAKE_INSTALL_PREFIX}\""
)

#安装ukui-panel
install(TARGETS ${PROJECT_NAME} RUNTIME DESTINATION bin)
#DESKTOP FILE
install(FILES ${DESKTOP_FILE} DESTINATION "/etc/xdg/autostart/" COMPONENT Runtime)
install(FILES ${UKUI_PANEL_CONFIG_FILES} DESTINATION ${CMAKE_INSTALL_DATADIR}/ukui)
install(FILES ${PUB_HEADERS} DESTINATION include/ukui)
install(FILES ${UKUI_PANEL_MAN} DESTINATION "${CMAKE_INSTALL_MANDIR}/man1" COMPONENT Runtime)
install(FILES ${GSETTINGS_FILE} DESTINATION "/usr/share/glib-2.0/schemas" COMPONENT Runtime)
install(FILES ${PANEL_GLOBAL_CONFIG_FILES} DESTINATION "/usr/share/ukui/ukui-panel" COMPONENT Runtime
    PERMISSIONS OWNER_WRITE OWNER_READ GROUP_READ GROUP_WRITE WORLD_READ WORLD_WRITE)
install(FILES ${PANEL_GLOBAL_CONFIG_EXEC_FILES} DESTINATION "/usr/share/ukui/ukui-panel" COMPONENT Runtime
    PERMISSIONS OWNER_EXECUTE OWNER_WRITE OWNER_READ GROUP_EXECUTE GROUP_READ GROUP_WRITE WORLD_READ WORLD_WRITE WORLD_EXECUTE)
install(DIRECTORY ${IMAGE_DIR} DESTINATION "${PACKAGE_DATA_DIR}/panel/img")

set(PLUGIN panel)
set(PANEL_TRANSLATION_DIR "${PACKAGE_DATA_DIR}/panel/translation")
add_compile_definitions(PANEL_TRANSLATION_DIR="${PANEL_TRANSLATION_DIR}")
install(FILES ${QM_FILES} DESTINATION "${PANEL_TRANSLATION_DIR}")

=== plugin-showdesktop/CMakeLists.txt ===
set(PLUGIN "showdesktop")

set(HEADERS
    showdesktop.h
)

set(SOURCES
    showdesktop.cpp
)

#加载翻译文件
file(GLOB TS_FILES "${PROJECT_SOURCE_DIR}/plugin-showdesktop/translation/*.ts" )
#更新翻译文件并创建.qm文件
qt5_create_translation(QM_FILES ${PROJECT_SOURCE_DIR}/plugin-showdesktop ${TS_FILES})

set(${PLUGIN}_QM_FILES ${QM_FILES})

BUILD_UKUI_PLUGIN(${PLUGIN})

#安装翻译文件
set(SHOWDESKTOP_TRANSLATION_DIR "${PACKAGE_DATA_DIR}/plugin-showdesktop/translation")
add_compile_definitions(SHOWDESKTOP_TRANSLATION_DIR="${SHOWDESKTOP_TRANSLATION_DIR}")

install(FILES ${QM_FILES} DESTINATION ${SHOWDESKTOP_TRANSLATION_DIR})

=== plugin-spacer/CMakeLists.txt ===
set(PLUGIN "spacer")

set(HEADERS
    spacer.h
)

set(SOURCES
    spacer.cpp
)


BUILD_UKUI_PLUGIN(${PLUGIN})

=== plugin-startbar/CMakeLists.txt ===
set(PLUGIN "startbar")

set(HEADERS
    startbar.h
    startmenu_button.h
    taskview_button.h
    divider.h
)

set(SOURCES
    startbar.cpp
    startmenu_button.cpp
    taskview_button.cpp
    divider.cpp
)

set(UIS
)

set(LIBRARIES
)

install(FILES
    img/search.png
    DESTINATION "${PACKAGE_DATA_DIR}/plugin-assistant/img"
    COMPONENT Runtime
)

#加载翻译文件
file(GLOB TS_FILES "${PROJECT_SOURCE_DIR}/plugin-startbar/translation/*.ts" )
#更新翻译文件并创建.qm文件
qt5_create_translation(QM_FILES ${PROJECT_SOURCE_DIR}/plugin-startbar ${TS_FILES})
set(${PLUGIN}_QM_FILES ${QM_FILES})

BUILD_UKUI_PLUGIN(${PLUGIN})

#安装翻译文件
set(STARTBAR_TRANSLATION_DIR "${PACKAGE_DATA_DIR}/plugin-startbar/translation")
add_compile_definitions(STARTBAR_TRANSLATION_DIR="${STARTBAR_TRANSLATION_DIR}")
install(FILES ${QM_FILES} DESTINATION ${STARTBAR_TRANSLATION_DIR})

=== plugin-statusnotifier/CMakeLists.txt ===
set(PLUGIN "statusnotifier")

find_package(dbusmenu-qt5 REQUIRED)

set(HEADERS
    statusnotifier.h
    dbustypes.h
    statusnotifierbutton.h
    statusnotifieriteminterface.h
    statusnotifierwatcher.h
#    statusnotifierwidget.h
    sniasync.h
    statusnotifier_storagearrow.h
    statusnotifierwatcher_interface.h
    systemtraytypedefs.h
    dbusproperties.h
    statusnotiferscrollarea.h
    statusnotifierbuttonabstract.h
)

set(SOURCES
    statusnotifier.cpp
    dbustypes.cpp
    statusnotifierbutton.cpp
    statusnotifieriteminterface.cpp
    statusnotifierwatcher.cpp
#    statusnotifierwidget.cpp
    sniasync.cpp
    statusnotifier_storagearrow.cpp
    statusnotifierwatcher_interface.cpp
    dbusproperties.cpp
    statusnotiferscrollarea.cpp
    statusnotifierbuttonabstract.cpp
)

qt5_add_dbus_adaptor(DBUS_SOURCES
    org.kde.StatusNotifierItem.xml
    statusnotifieriteminterface.h
    StatusNotifierItemInterface
)

set_source_files_properties(${DBUS_SOURCES} PROPERTIES SKIP_AUTOGEN ON)

list(APPEND SOURCES "${DBUS_SOURCES}")

set(LIBRARIES
    dbusmenu-qt5
)

#加载翻译文件
file(GLOB TS_FILES "${PROJECT_SOURCE_DIR}/plugin-statusnotifier/translation/*.ts" )
#更新翻译文件并创建.qm文件
qt5_create_translation(QM_FILES ${PROJECT_SOURCE_DIR}/plugin-statusnotifier ${TS_FILES})
set(${PLUGIN}_QM_FILES ${QM_FILES})

BUILD_UKUI_PLUGIN(${PLUGIN})

#安装翻译文件
set(STATUSNOTIFIER_TRANSLATION_DIR "${PACKAGE_DATA_DIR}/plugin-statusnotifier/translation")
add_compile_definitions(STATUSNOTIFIER_TRANSLATION_DIR="${STATUSNOTIFIER_TRANSLATION_DIR}")
install(FILES ${QM_FILES} DESTINATION ${STATUSNOTIFIER_TRANSLATION_DIR})

=== plugin-ukcc/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(plugin-panel LANGUAGES CXX)

set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

find_package(Qt5 COMPONENTS Core Widgets LinguistTools REQUIRED)
find_package(PkgConfig)

pkg_search_module(SDK_WIDGET REQUIRED kysdk-qtwidgets)
pkg_check_modules(Gsetting REQUIRED gsettings-qt)
pkg_check_modules(GIO2 REQUIRED gio-2.0)
pkg_check_modules(GIOUNIX2 REQUIRED gio-unix-2.0)

#加载翻译文件
file(GLOB TS_FILES "${PROJECT_SOURCE_DIR}/translation/*.ts" )
#更新翻译文件并创建.qm文件
qt5_create_translation(QM_FILES ${PROJECT_SOURCE_DIR} ${TS_FILES})

add_library(plugin-panel SHARED
            ${QM_FILES}
            ukccplugin.h ukccplugin.cpp
            generalsettings.h generalsettings.cpp
            alwaysdisplayonpanel.h alwaysdisplayonpanel.cpp
 )
include_directories(${SDK_WIDGET_INCLUDE_DIRS}
    ${Gsetting_INCLUDE_DIRS}
    ${GIO2_INCLUDE_DIRS}
    ${GIOUNIX2_INCLUDE_DIRS})
target_link_directories(plugin-panel PRIVATE ${SDK_WIDGET_LIBRARY_DIRS})
target_link_libraries(plugin-panel PRIVATE Qt5::Core Qt5::Widgets Qt5::Gui -lukcc
    ${Gsetting_LIBRARIES}
    ${GIO2_LIBRARIES}
    ${GIOUNIX2_LIBRARIES}
    ${SDK_WIDGET_LIBRARIES}
    )

target_compile_definitions(plugin-panel PRIVATE UNTITLED5_LIBRARY)

get_target_property(QT_QMAKE_EXECUTABLE ${Qt5Core_QMAKE_EXECUTABLE} IMPORTED_LOCATION)
macro(query_qmake args output)
    exec_program(${QT_QMAKE_EXECUTABLE} ARGS -query ${args} OUTPUT_VARIABLE ${output} RETURN_VALUE exitCode)
    if(NOT ${exitCode} EQUAL 0)
        message(FATAL_ERROR "exec ${QT_QMAKE_EXECUTABLE} failed.")
    endif()
endmacro()
query_qmake("QT_INSTALL_LIBS" QT_INSTALL_LIBS)
#安装目标文件libplugin-panel.so
install(TARGETS ${PROJECT_NAME} DESTINATION ${QT_INSTALL_LIBS}/ukui-control-center)
message(STATUS ${QT_INSTALL_LIBS})
#安装翻译文件
set(UKCCPANEL_TRANSLATION_DIR "${PACKAGE_DATA_DIR}/plugin-ukccpanel/translation")
add_compile_definitions(UKCCPANEL_TRANSLATION_DIR="${UKCCPANEL_TRANSLATION_DIR}")
install(FILES ${QM_FILES} ${TS_FILES} DESTINATION ${UKCCPANEL_TRANSLATION_DIR})

=== sni-daemon/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1.0)

project(sni-daemon)

set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_AUTOUIC ON)

if(CMAKE_VERSION VERSION_LESS "3.7.0")
    set(CMAKE_INCLUDE_CURRENT_DIR ON)
endif()

find_package(Qt5 COMPONENTS Widgets Network DBus REQUIRED)
find_package(PkgConfig REQUIRED)

add_executable(sni-daemon
        main.cpp
        snidaemon.cpp
        statusnotifieritem_interface.cpp

        snidaemon.h
        statusnotifieritem_interface.h
        systemtraytypedefs.h
)

target_link_libraries(sni-daemon
    Qt5::Widgets
    Qt5::DBus
    -lukui-log4qt
    )

add_definitions(-DQT_MESSAGELOGCONTEXT)

install(TARGETS sni-daemon DESTINATION bin)

install(FILES
    resources/sni-daemon.desktop
    DESTINATION "/etc/xdg/autostart/"
    COMPONENT Runtime
)

=== sni-xembed-proxy/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1.0)

project(sni-xembed-proxy)

set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_AUTOUIC ON)

if(CMAKE_VERSION VERSION_LESS "3.7.0")
    set(CMAKE_INCLUDE_CURRENT_DIR ON)
endif()

find_package(Qt5 COMPONENTS Widgets Network REQUIRED)
find_package(Qt5DBus REQUIRED)
find_package(PkgConfig REQUIRED)
find_package(KF5WindowSystem REQUIRED)
find_package(Qt5X11Extras REQUIRED)
find_package(X11 REQUIRED)


QT5_ADD_DBUS_INTERFACE(libqtxdg_DBUS_INTERFACE_SRCS
    ../panel/xdg-desktop-file/dbus/org.freedesktop.Application.xml
    application_interface
)

add_executable(sni-xembed-proxy
        main.cpp
        snixembedproxy.cpp
        sniproxy.cpp
        snidbus.cpp
        statusnotifierwatcher_interface.cpp
        xtestsender.cpp
        ../panel/xdg-desktop-file/desktopenvironment_p.cpp
        ../panel/xdg-desktop-file/xdgdesktopfile.cpp
        ../panel/xdg-desktop-file/xdgdirs.cpp


        snixembedproxy.h
        sniproxy.h
        snidbus.h
        statusnotifierwatcher_interface.h
        systemtraytypedefs.h
        xcbutilss.h
        xtestsender.h
        ../panel/xdg-desktop-file/xdgdesktopfile_p.h
        ../panel/xdg-desktop-file/xdgdesktopfile.h
        ../panel/xdg-desktop-file/xdgdirs.h
        ../panel/xdg-desktop-file/xdgmacros.h
        ${libqtxdg_DBUS_INTERFACE_SRCS}

)



target_link_libraries(sni-xembed-proxy
    Qt5::X11Extras
    Qt5::Widgets
    Qt5::DBus
    KF5::WindowSystem
    xcb
    xcb-util
    xcb-damage
    xcb-image
    xcb-composite
    xcb-shape
    -lukui-log4qt
    ${XCB_LIBS}
    ${X11_XTest_LIB}
    )

add_definitions(-DQT_NO_KEYWORDS)
add_definitions(-DQT_MESSAGELOGCONTEXT)

install(TARGETS sni-xembed-proxy DESTINATION bin)

install(FILES
    resources/sni-xembed-proxy.desktop
    DESTINATION "/etc/xdg/autostart/"
    COMPONENT Runtime
)

=== plugin-taskbar/ukui-panel-items/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)
project(ukui-panel-items)

set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

#find QT modules
find_package(QT NAMES Qt6 Qt5 COMPONENTS Core Gui Qml Widgets Quick REQUIRED)
find_package(Qt${QT_VERSION_MAJOR} COMPONENTS Core Qml Gui Widgets Quick REQUIRED)
find_package(KF5WindowSystem REQUIRED)

#find other modules
find_package(PkgConfig REQUIRED)
set(PANEL_ITEM_PLUGIN_EXTERNAL_LIBS "")
set(PANEL_ITEM_PLUGIN_PC_PKGS gsettings-qt)
foreach(external_lib IN ITEMS ${PUBLIC_ITEM_PLUGIN_PC_PKGS})
    pkg_check_modules(${external_lib} REQUIRED IMPORTED_TARGET ${external_lib})
    if(${${external_lib}_FOUND})
        include_directories(${${external_lib}_INCLUDE_DIRS})
        link_directories(${${external_lib}_LIBRARY_DIRS})
        list(APPEND PUBLIC_ITEM_PLUGIN_EXTERNAL_LIBS PkgConfig::${external_lib})
    endif()
endforeach()

include_directories(.)
include_directories(qml)

set(PLUGIN_SRCS
        panel-public-plugin.h
        panel-public-plugin.cpp
        theme-palette.h
        theme-palette.cpp
        theme-icon.h
        theme-icon.cpp
        tooltip.h
        tooltip.cpp
        )
add_library(${PROJECT_NAME} SHARED ${PLUGIN_SRCS})

set(PLUGIN_IMPORT_URI "org.ukui.panel.items")
set(PLUGIN_INSTALL_PATH "/usr/lib/${CMAKE_LIBRARY_ARCHITECTURE}/qt5/qml/org/ukui/panel/items")
target_compile_definitions(${PROJECT_NAME} PRIVATE PLUGIN_IMPORT_URI="${PLUGIN_IMPORT_URI}")

target_link_libraries(${PROJECT_NAME}
        PRIVATE
        Qt${QT_VERSION_MAJOR}::Core
        Qt${QT_VERSION_MAJOR}::Qml
        Qt${QT_VERSION_MAJOR}::Gui
        Qt${QT_VERSION_MAJOR}::Quick
        Qt${QT_VERSION_MAJOR}::Gui_EGL
        Qt${QT_VERSION_MAJOR}::GuiPrivate
        Qt${QT_VERSION_MAJOR}::Widgets
        KF5::WindowSystem
        ${PUBLIC_ITEM_PLUGIN_EXTERNAL_LIBS}
    )

install(DIRECTORY "qml" DESTINATION "${PLUGIN_INSTALL_PATH}")
install(FILES "qmldir" DESTINATION "${PLUGIN_INSTALL_PATH}")
install(TARGETS ${PROJECT_NAME} LIBRARY DESTINATION ${PLUGIN_INSTALL_PATH})

=== debian/changelog ===
ukui-panel (4.0.0.6-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix FTBFS with CMake 4. (Closes: #1113600)

 -- Adrian Bunk <bunk@debian.org>  Wed, 08 Oct 2025 22:23:32 +0300

ukui-panel (4.0.0.6-1) unstable; urgency=medium

  * New upstream release: drop libkf5screen.
  * d/control: Drop libkf5screen-dev. (Closes: #1079813)

 -- handsome_feng <jianfengli@ubuntukylin.com>  Mon, 14 Apr 2025 19:22:09 +0800

=== debian/control ===
Source: ukui-panel
Section: x11
Priority: optional
Maintainer: kylin Team <team+kylin@tracker.debian.org>
Uploaders: Aron Xu <aron@debian.org>,
           handsome_feng <jianfengli@ubuntukylin.com>,
           xibowen <xibowen@kylinos.cn>
Build-Depends: cmake,
               debhelper-compat (= 13),
               extra-cmake-modules,
               libdbusmenu-qt5-dev,
               libdrm-dev,
               libglib2.0-dev(>=2.36),
               libgsettings-qt-dev,
               libkf5i18n-dev,
               libkf5wayland-dev,
               libkf5windowsystem-dev,
               libkysdk-applications-dev,
               libkysdk-base-dev,
               libpipewire-0.3-dev,
               libqt5waylandclient5-dev,
               libqt5x11extras5-dev,
               libukcc-dev,
               libukui-log4qt-dev,
               libx11-dev,
               libxcb-composite0-dev,
               libxcb-damage0-dev,
               libxcb-image0-dev,
               libxcb-shape0-dev,
               libxcb-util-dev,
               libxtst-dev,
               plasma-wayland-protocols,
               qtbase5-dev,
               qtbase5-private-dev,
               qtdeclarative5-dev,
               qttools5-dev,
               qtwayland5-dev-tools
Standards-Version: 4.6.1.0
Rules-Requires-Root: no
Homepage: https://gitee.com/openkylin/ukui-panel
Vcs-Git: https://gitee.com/openkylin/ukui-panel.git
Vcs-Browser: https://gitee.com/openkylin/ukui-panel

Package: ukui-panel
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Provides: ukui-indicators
Suggests: time-shutdown, ukui-window-switch (>=3.0.0-3)
Description: ukui desktop panel
 The ukui desktop panel is used on ukui desktop and has some plugins like
 starmenu, quicklaunch and other useful tools.
 .
 This package contains the ukui panel.

=== debian/rules ===
#!/usr/bin/make -f
# export DH_VERBOSE=1

export LC_ALL=C.UTF-8
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

WHICH_OS := $(shell dpkg-architecture -qDEB_HOST_ARCH_OS 2>/dev/null)

ifeq ($(WHICH_OS), kfreebsd)
    NOT_LINUX := -DCPULOAD_PLUGIN=NO -DNETWORKMONITOR_PLUGIN=NO -DVOLUME_PLUGIN=NO
endif

ifeq ($(WHICH_OS), hurd)
    NOT_LINUX := -DCPULOAD_PLUGIN=NO -DNETWORKMONITOR_PLUGIN=NO -DVOLUME_PLUGIN=NO -DSENSORS_PLUGIN=NO
endif

%:
	dh ${@} --buildsystem cmake

override_dh_auto_configure:
	 dh_auto_configure -- -D_FORTIFY_SOURCE=2\
		-DPULL_TRANSLATIONS=OFF \
		-DUPDATE_TRANSLATIONS=OFF \
		-DDOM_PLUGIN=OFF \
		-DCMAKE_BUILD_TYPE=RelWithDebInfo \
		$(NOT_LINUX)

=== debian/watch ===
version=4
https://github.com/ukui/ukui-panel/releases .*/ukui-panel_(\d\S+)\.orig\.tar\.gz
